#!/bin/bash

#set -vx

#mkdir GUIDAGE
mkdir -p GUIDAGE
cd GUIDAGE
ln -s ../INITIAL/grilles_gcm.nc .

lmax=120 # on devrait pouvoir aller jusqu'a 124 mais ca ne marche pas ...

dirrea=./
path_erai=ERAI/NETCDF/GLOBAL_075/4xdaily/AN_PL/2011
file_erai=201101.aphei.GLOBAL_075

mainrea=3DInputData/ReAnalyses
lmdzpub=~/LMDZ/pub/$mainrea
www=http://www.lmd.jussieu.fr/~lmdz/pub/$mainrea

# A function to fetch files either locally or on the internet
function myget { #1st and only argument should be file name
  # Path on local computer where to look for the datafile
  if [ -f /u/lmdz/WWW/LMDZ/pub/$1 ] ; then
    \cp -f -p /u/lmdz/WWW/LMDZ/pub/$1 .
  elif [ -f ~/LMDZ/pub/$1 ] ; then
    \cp -f -p ~/LMDZ/pub/$1 .
  else
    wget http://www.lmd.jussieu.fr/~lmdz/pub/$1
    dir=~/LMDZ/pub/`dirname $1` ; mkdir -p $dir ; cp -r `basename $1` $dir
  fi
}

#for var in u v ; do
#path_erai=ERAI/NETCDF/GLOBAL_075/4xdaily/AN_PL/2011
#file_erai=201101.aphei.GLOBAL_075
#file=$var.$file_erai.nc
#echo myget $mainrea/$path_erai/$file
#myget $mainrea/$path_erai/$file
#done

# Expert : get other months or years throug dods
#    dirrea=http://dodsp.idris.fr/cgi-bin/nph-dods/rpsl500
# OpenDAP link
#     dirrea=https://prodn.idris.fr/thredds/dodsC/ipsl_public/rpsl500
# Interpolation avec CDO
# from L. Guez
###############################
echo 'Interpolating u and v with cdo'
###############################
# Define the grids needed
for grille in grille_u grille_v
do
    ncks --overwrite --variable=$grille grilles_gcm.nc $grille.nc
done
###############################
echo 'Extracting u and v '
###############################
for var in u v
do
    path_erai=ERAI/NETCDF/GLOBAL_075/4xdaily/AN_PL/2011
    file_erai=201101.aphei.GLOBAL_075
    file=$var.$file_erai.nc
    echo myget $mainrea/$path_erai/$file
    myget $mainrea/$path_erai/$file
    ncpdq --overwrite --dimension=time,0,120 --unpack \
      $var.201101.aphei.GLOBAL_075.nc ${var}_ERAI.nc
###############################
    echo "Remapping ${var}, inverting latitudes and levels"
###############################
    cdo remapbil,grille_${var}.nc ${var}_ERAI.nc ${var}_lat_lev.nc
    cdo invertlev -invertlat ${var}_lat_lev.nc tmp${var}.nc
    rm ${var}_lat_lev.nc ${var}_ERAI.nc
done


###############################
echo 'Renaming variables'
###############################
ncrename -v u,UWND -v level,LEVEL -d level,LEVEL -v lonu,LONU -d lonu,LONU \
         -d latu,LATU -v latu,LATU tmpu.nc u.nc
ncrename -v v,VWND -v level,LEVEL -d level,LEVEL -v lonv,LONV -d lonv,LONV \
         -d latv,LATV -v latv,LATV tmpv.nc v.nc
rm grille_[uvs].nc tmpu.nc tmpv.nc



echo Vous pouvez aussi recuperer les scripts plus automatiques sur
echo svn co http://forge.ipsl.jussieu.fr/igcmg/svn/CONFIG/LMDZOR/branches/LMDZOR_v4/CREATE/SCRIPT
echo et modifier dans SCRIPT/interp_from_era.ksh .
echo 'indir=..'
echo 'gridfile=.../grilles_gcm.nc'
echo 'varlist="u v" ( les variables a interpoler ) '
echo 'outdir=..'
echo 'first_year=2011'
echo 'last_year=2011'
echo 'rundir=.'
